#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> g;
vector<bool> used;
vector<int> deg;

void dfs(int u)
{
  used[u] = true;
  deg[u] = g[u].size();
  for(auto v:g[u])
    if(!used[v])
      dfs(v);
}

signed main()
{
  #ifdef _DEBUG
  freopen("in.txt","rt",stdin);
  #endif // _DEBUG

  int n,m;
  cin >> n >> m;

  g.resize(n+1);
  used.resize(n+1, false);
  deg.resize(n+1);

  for(int i=2;i<=n;i++)
  {
    int p;
    cin >> p;
    g[p].push_back(i);
    g[i].push_back(p);
  }

  /*
  for(int i=1;i<=n;i++)
  {
    cout << i << " : ";
    for(auto a:g[i])
      cout << a << " ";
    cout << "\n";
  }
  */


  dfs(1);

  /*
  for(int i=1;i<=n;i++)
    cout << i << " : " << deg[i] << "\n";
  */

  int anw = 0;
  for(int i=1;i<=n;i++)
  {
    if(deg[i] == 1)
    {

      queue<int> q;
      used.assign(used.size(), false);
      vector<int> dist(n+1);
      dist[i] = 0;
      q.push(i);
      used[i] = true;
      while(!q.empty())
      {
        int cur = q.front();
        q.pop();

        for(auto v:g[cur])
        {
          if(!used[v])
          {
            dist[v] = dist[cur] + 1;
            anw = max(dist[v], anw);
            q.push(v);
            used[v] = true;
          }
        }
      }

      /*
      cout << "if " << i << " is root" << " : ";
      for(int j=1;j<=n;j++)
        cout << dist[j] << " ";
      cout << "\n";
      */
    }
  }

  cout << anw + 1;

  return 0;
}
