#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> g;
vector<bool> used;
vector<int> deg;
vector<int> distfromroot;

void dfs(int u, int par = -1)
{
  used[u] = true;
  deg[u] = g[u].size();

  if(par != -1)
    distfromroot[u] = distfromroot[par] + 1;

  for(auto v:g[u])
    if(!used[v])
      dfs(v, u);
}

signed main()
{
  #ifdef _DEBUG
  freopen("in.txt","rt",stdin);
  #endif // _DEBUG

  int n,m;
  cin >> n >> m;

  g.resize(n+1);
  used.resize(n+1, false);
  deg.resize(n+1);
  distfromroot.resize(n+1);

  for(int i=2;i<=n;i++)
  {
    int p;
    cin >> p;
    g[p].push_back(i);
    g[i].push_back(p);
  }

  /*
  for(int i=1;i<=n;i++)
  {
    cout << i << " : ";
    for(auto a:g[i])
      cout << a << " ";
    cout << "\n";
  }
  */

  distfromroot[1] = 0;
  dfs(1);

  /*
  for(int i=1;i<=n;i++)
    cout << i << " : " << deg[i] << "\n";
  */

  int ver, maxdist = 0;
  for(int i=1;i<=n;i++)
  {
    if(distfromroot[i] > maxdist)
    {
      ver = i;
      maxdist = distfromroot[i];
    }
  }

  //cout << ver << " " << maxdist << "\n";

  int anw = 0;
  queue<int> q;
  used.assign(used.size(), false);
  vector<int> dist(n+1);
  dist[ver] = 0;
  q.push(ver);
  used[ver] = true;
  while(!q.empty())
  {
    int cur = q.front();
    q.pop();

    for(auto v:g[cur])
    {
      if(!used[v])
      {
        dist[v] = dist[cur] + 1;
        anw = max(dist[v], anw);
        q.push(v);
        used[v] = true;
      }
    }
  }


  cout << anw + 1;

  return 0;
}
